function isBlocklandRebuilt ()
{
	return false;
}

if (!isBlocklandRebuilt ())
{
	error ("ERROR: This add-on only works with Blockland Rebuilt.");
	return;
}

function showcase()
{
	exec("add-ons/client_mainmenubuildshowcase/client.cs");
}

function showcase2()
{
	MM_BuildPreview.loadBlocklandSave ("Bedroom", "Demo House");
}

function showcase3()
{
	MM_BuildPreview.loadBlocklandSave ("Bedroom", "Arch of Constantine");
}

function showcase4()
{
	MM_BuildPreview.loadBlocklandSave ("Bedroom", "Mansion");
}

function showcase5()
{
	MM_BuildPreview.loadBlocklandSave ("Slate", "Erikas_Blockparty");
}

// Obviously this is enabled by default. Because it's an awesome feature. Who needs stupid screenshots anyways. Boring!
if ($pref::Client::BuildShowcase::Enabled $= "")
	$pref::Client::BuildShowcase::Enabled = "1";

if (isObject (Canvas))
{
	if (!isObject (OptAutoOpenConsoleOnLaunchToggle))
	{
		error ("Client_MainMenuBuildShowcase: wtf did you do to your rebuilt installation. where is the 'open console on launch' toggle.");
		error ("Client_MainMenuBuildShowcase: now we can't add our toggle to the options menu!!! this is BAD.");
	}
	else
	{
		%miscOptPanel = OptAutoOpenConsoleOnLaunchToggle.getGroup ();
		%boringOption = new GuiCheckBoxCtrl (OptShowBuildShowcaseToggle)
		{
			canSaveDynamicFields = "0";
			Profile = "GuiCheckBoxProfile";
			HorizSizing = "right";
			VertSizing = "bottom";
			position = "0 0";
			Extent = "561 25";
			MinExtent = "8 8";
			canSave = "1";
			Visible = "1";
			Variable = "$pref::Client::BuildShowcase::Enabled";
			Command = "MM_BuildPreview.updateBuildShowcase ();";
			locale = "GlobalLocale";
			applyLocaleToChildren = "0";
			hovertime = "1000";
			pitch = "1";
			groupNum = "-1";
			buttonType = "ToggleButton";
			text = "Main-Menu: Show build showcases instead of screenshots";
			textID = "UI_OPTIONS_SHOW_BRICK_SHOWCASE_ON_MAINMENU";
			textOverflow = "Inherit From Profile";
			useLegacyOverflowForEnglish = "1";
			ignoreTextHoverOnEnglish = "1";
			ignoreTextMarginOnEnglish = "1";
			useInactiveState = "0";
		};
		
		%miscOptPanel.add (%boringOption);
		
		// Now position ourselves
		%boringOption.setPosition (24, %miscOptPanel.getLargestChildY () - 9);
		
		// And then expand the lovely GUI
		%miscOptPanel.setExtent (%miscOptPanel.getWidth (), %boringOption.getRectBottom () - 2);
		
		// And then expand the lovely GUI behind that
		%miscOptPanel.getGroup ().setExtent (%miscOptPanel.getWidth (), %miscOptPanel.getGroup ().getLargestChildY () + 3);
	}
}

exec("./bls_to_blrs.cs");
exec("./poser.cs");

package MainMenuBuildPreviewPackage
{
	function loadMainMenu()
	{
		%Thingy = new GuiSwatchCtrl (MM_BuildPreviewBG)
		{
			profile = "GuiDefaultProfile";
			position = "0 0";
			extent = "640 480";
			HorizSizing = "width";
			VertSizing = "height";
			color = "126 193 236 255";
		};
		
		mainMenuGui.add (%Thingy);
		
		%Thingy = new GuiCustomSceneCtrl(MM_BuildPreview)
		{
			profile = "GuiDefaultProfile";
			position = "0 0";
			extent = "640 480";
			HorizSizing = "width";
			VertSizing = "height";
			defaultOrbitPos = "0 0 0";
			maxOrbitDist = 50;
			ambientColor = "0.4 0.4 0.4 1";
			lightColor = "0.8 0.8 0.8 1";
			maxOrbitDist = 9000;
			canMoveCamera = 1;
			canControl = 1;
			forceFov = 51;
			desiredFov = 51;
			lightForward = 1;
			useSkyTextures = 1;
			skyColor = "126 193 236 255";
			renderFog = 0;
			renderSky = $pref::skyOn;

			new GuiMLTextCtrl(MM_BuildPreviewFreeCamTip)
			{
				canSaveDynamicFields = "0";
				Profile = "MM_LeftProfile";
				HorizSizing = "right";
				VertSizing = "top";
				position = "8 458";
				Extent = "217 18";
				MinExtent = "1 1";
				canSave = "1";
				Visible = "1";
				hovertime = "1000";
				text = "";
				tipText = "Right click to leave freecam mode.";
				maxLength = "1024";
				scrollText = "0";
				alpha = "0";
			};
			
			new GuiBitmapCtrl(MM_BuildPreviewCrosshair)
			{
				Profile = "GuiBitmapCtrl";
				HorizSizing = "center";
				VertSizing = "center";
				position = "304 224";
				Extent = "32 32";
				MinExtent = "1 1";
				bitmap = "base/client/ui/crossHair";
				mColor = "255 255 255 0";
			};
		};
		
		mainMenuGui.add (%Thingy);
		mainMenuGui.bringToFront (MM_BuildPreview);
		mainMenuGui.bringToFront (MM_BuildPreviewBG);
		
		MM_BG.setVisible(false);
		
		Parent::loadMainMenu();
		
		MM_BuildPreview.LoadRandomBuild ();
	}
	function optionsDlg::onWake (%this)
	{
		MM_BuildPreview.oldFOV      = MM_BuildPreview.overrideFOV;
		MM_BuildPreview.overrideFOV = $pref::Player::defaultFov;
		
		Parent::onWake (%this);
	}
	function optionsDlg::onSleep (%this)
	{
		Parent::onSleep (%this);
		MM_BuildPreview.overrideFOV = MM_BuildPreview.oldFOV;
	}
	function optionsDlg::updateFov (%this)
	{
		Parent::updateFov (%this);
		MM_BuildPreview.overrideFOV = $pref::Player::defaultFov;
	}
	function OptGraphicsSkyToggle::onAction (%this)
	{
		//Parent::onAction (%this);
		MM_BuildPreview.renderSky = $pref::skyOn;
	}
	function optionsDlg::setPane (%this, %pane)
	{
		Parent::setPane (%this, %pane);
		if (%pane $= "Graphics")
		{
			MM_BuildPreview.overrideFOV = $pref::Player::defaultFov;
		}
		else
		{
			MM_BuildPreview.overrideFOV = MM_BuildPreview.oldFOV;
		}
	}
};

activatePackage (MainMenuBuildPreviewPackage);

function MM_BuildPreview::updateBuildShowcase (%this)
{
	// If we don't want it, we'll go ahead and hide the thing.
	if (!$pref::Client::BuildShowcase::Enabled)
	{
		// Cleanup our memory profile so we don't waste a bunch of space.
		MM_BuildPreview.cleanupMemory ();
		
		// Hide it & show the original screenshots
		MM_BuildPreview.setVisible (false);
		MM_BG.setVisible (true);
		
		// Load the stupid screenshots. Some of them are probably precious memories. Bricks are better
		MainMenuGui.updateScreenshots ();
		
		// Done!
		return;
	}
	
	// Show our beautiful bricks
	MM_BuildPreview.setVisible (true);
	MM_BG.setVisible (false);
	
	// Show a random lovely build
	MM_BuildPreview.loadRandomBuild ();
}

function MM_BuildPreviewTickTextAnim (%object, %firstTick, %normalizedTime)
{
	%color      = mLerpI ($Math::Lerp::Method::Linear, %object.start, %object.end, %normalizedTime);
	%colorTag   = "<color:FFFFFF" @ mInt2Hex (mFloor (%color)) @ ">";
	%outlineTag = "<outlinea:" @ %object.profile.fontOutlineWidth @ ":" @ mInt2Hex (getWord (%object.profile.fontOutlineColor, 0)) @ mInt2Hex (getWord (%object.profile.fontOutlineColor, 1)) @ mInt2Hex (getWord (%object.profile.fontOutlineColor, 2));
	%outlineTag = %outlineTag @ mInt2Hex (mFloor (%color)) @ ">";
	
	MM_BuildPreviewFreeCamTip.setText (%colorTag @ %outlineTag @ %object.tipText);
}

function MM_BuildPreview::getCameraStats (%this)
{
	%data = "CAMERA_DIST " @ %this.getOrbitDist () @ "\r\n";
	%data = %data @ "ORBIT_POS " @ %this.getOrbitPos () @ "\r\n";
	%data = %data @ "CAMERA_POS " @ %this.getCameraPosition () @ "\r\n";
	%data = %data @ "CAMERA_ROT " @ %this.getCameraRotation ();
	
	setClipboard (%data);
}

function MM_BuildPreview::stop (%this)
{
	%this.setGlobalSpinSpeed (0);
}

function MM_BuildPreview::onWake (%this)
{
	%this.setFocus (1);
	cancel (%this.cleanupMemorySchedule);
}

function MM_BuildPreview::onSleep (%this)
{
	%this.cleanupMemorySchedule = %this.schedule (1000, cleanupMemory);
}

function MM_BuildPreview::LoadRandomSky (%this)
{
	if (%this.skyCount > 0)
	{
		%randomFile = %this.skies[getRandom (0, %this.skyCount - 1)];
		if (%randomFile $= "")
		{
			%this.useSkyTextures = false;
			return;
		}
	}
	else
	{
		%fileCount = 0;
		for (%file = FindFirstFile ("Add-Ons/Sky_*.zip"); %file !$= ""; %file = FindNextFile ("Add-Ons/Sky_*.zip"))
		{
			%basePath = "Add-Ons/" @ fileBase (%file) @ "/";
			%skyName  = getSubStr (fileBase (%file), strLen ("Sky_"), strLen (fileBase (%file)));
			
			if (%skyName $= "Blank")
				continue;
			
			// Check to see if all of the relevant files are there
			if (!isFile (%basePath @ %skyName @ ".atmosphere") || !isFile (%basePath @ %skyName @ ".dml"))
				continue;
			
			%files[%fileCount] = (%basePath @ %skyName @ ".atmosphere") NL (%basePath @ %skyName @ ".dml") NL %skyName NL "0";
			%fileCount++;
		}
		
		%randomFile = %files[getRandom (0, %fileCount - 1)];
		if (%randomFile $= "")
		{
			%this.useSkyTextures = false;
			return;
		}
	}
	
	// Load up the textures
	%this.useSkyTextures = true;
	if (!%this.loadSkyAtmosphere (getRecord (%randomFile, 0)))
	{
		error("ERROR: MM_BuildPreview::LoadRandomSky() - Failed to load sky atmosphere \"" @ getRecord (%randomFile, 0) @ "\".");
	}
	if (!%this.loadSkyDML (getRecord (%randomFile, 1)))
	{
		error("ERROR: MM_BuildPreview::LoadRandomSky() - Failed to load sky dml \"" @ getRecord (%randomFile, 0) @ "\".");
	}
	%this.lightForward = getRecord (%randomFile, 3);
	
	if (%this.farPlane < 500)
		%this.farPlane = 500;
	
	echo ("Loaded random sky \"" @ getRecord (%randomFile, 2) @ "\"");
}

function MM_BuildPreview::LoadRandomGround (%this)
{
	%fileCount = 0;
	for (%file = FindFirstFile ("Add-Ons/Ground_*/*.ground"); %file !$= ""; %file = FindNextFile ("Add-Ons/Ground_*/*.ground"))
	{
		%files[%fileCount] = %file;
		%fileCount++;
	}
	
	%randomFile = %files[getRandom (0, %fileCount - 1)];
	if (%randomFile $= "")
		return;
	
	%SO = new FileObject ();
	if (!%SO.openForRead (%randomFile))
	{
		error ("ERROR: MM_BuildPreview::LoadRandomGround() - Failed to load ground \"" @ %randomFile @ "\".");
		%SO.delete ();
		return;
	}
	
	while (!%SO.isEOF ())
	{
		%line = %SO.readLine ();
		
		if (firstWord (%line) $= "$Ground::topTexture")
		{
			%this.setTexture ("groundPlane", removeWord (%line, 0), 0, true);
		}
		if (firstWord (%line) $= "$Ground::Color")
		{
			%this.setNodeColor ("groundPlane", "ALL", getColorF (removeWord (%line, 0)));
		}
	}
	
	%SO.close ();
	%SO.delete ();
	
	echo ("Loaded random ground \"" @ %randomFile @ "\"");
}

function MM_BuildPreview::CancelLoad (%this)
{
	// Cancel our schedule
	cancel (%this.loadBricksSchedule);
	
	// Delete the file object
	if (isObject (%this.loadBricksFileObject))
	{
		%this.loadBricksFileObject.close ();
		%this.loadBricksFileObject.delete ();
	}
}

function MM_BuildPreview::LoadRandomBuild (%this)
{
	if (!isFile ("config/client/buildShowcase/builds/readme.txt"))
	{
		// Write the readme file
		%SO = new FileObject ();
		%SO.openForWrite ("config/client/buildShowcase/builds/readme.txt");
		%SO.writeLine ("This is where you should put all the BLS files you want to see on the main menu.");
		%SO.close ();
		%SO.delete ();
	}
	
	// First, convert builds that have yet to be converted
	%ForceLoad = "";
	for (%Walk = FindFirstFile ("config/client/buildShowcase/builds/*.bls"); %Walk !$= ""; %Walk = FindNextFile("config/client/buildShowcase/builds/*.bls"))
	{
		%BlrsFile = "config/client/buildShowcase/builds/" @ fileBase (%Walk) @ ".blrs";
		
		// Skip if it's already converted
		if (isFile (%BlrsFile))
			continue;
		
		bls2blrs (%Walk);
		
		discoverFile (%BlrsFile);
		if (isFile (%BlrsFile) && %ForceLoad $= "")
			%ForceLoad = %BlrsFile;
	}
	
	if (%ForceLoad !$= "")
	{
		%this.LoadBackgroundBuild (fileBase (%ForceLoad));
		return;
	}
	
	%FileCount = 0;
	for (%Walk = FindFirstFile ("Add-Ons/Client_MainMenuBuildShowcase/builds/*.blrs"); %Walk !$= ""; %Walk = FindNextFile("Add-Ons/Client_MainMenuBuildShowcase/builds/*.blrs"))
	{
		%Files[%FileCount] = %Walk;
		%FileCount++;
		
		// Force randomness
		getRandom (0, getRandomSeed ());
	}
	
	for (%Walk = FindFirstFile ("config/client/buildShowcase/builds/*.blrs"); %Walk !$= ""; %Walk = FindNextFile("config/client/buildShowcase/builds/*.blrs"))
	{
		%Files[%FileCount] = %Walk;
		%FileCount++;
		
		// Force randomness
		getRandom (0, getRandomSeed ());
	}
	
	%this.LoadBackgroundBuild (fileBase (%Files[getRandom (0, %FileCount - 1)]));
}

function MM_BuildPreview::HandleEmitters (%this)
{
	if (!%this.isAwake ())
		return;
	
	if (%this.getActiveParticleCount () >= 100)
	{
		cancel (%this.handleEmittersSchedule);
		%this.handleEmittersSchedule = %this.schedule (32, HandleEmitters);
		return;
	}
	
	for (%i = 0; %i < $TSEmitterCount; %i++)
	{
		if (getSimTime () - $TSEmitter[%i, "lastEmitTime"] < $TSEmitter[%i, "ejectPeriodMS"])
			continue;
		
		$TSEmitter[%i, "lastEmitTime"] = getSimTime ();
		
		%SpawnPosX      = getWord ($TSEmitter[%i, "pos"], 0) + getRandomF (-($TSEmitter[%i, "spawnOffset"] / 2), ($TSEmitter[%i, "spawnOffset"] / 2));
		%SpawnPosY      = getWord ($TSEmitter[%i, "pos"], 1) + getRandomF (-($TSEmitter[%i, "spawnOffset"] / 2), ($TSEmitter[%i, "spawnOffset"] / 2));
		%SpawnPosZ      = getWord ($TSEmitter[%i, "pos"], 2) + getRandomF (-($TSEmitter[%i, "spawnOffset"] / 2), ($TSEmitter[%i, "spawnOffset"] / 2));
		%SpawnVelocityX = getRandomF (getWord ($TSEmitter[%i, "minVelocity"], 0), getWord ($TSEmitter[%i, "maxVelocity"], 0));
		%SpawnVelocityY = getRandomF (getWord ($TSEmitter[%i, "minVelocity"], 1), getWord ($TSEmitter[%i, "maxVelocity"], 1));
		%SpawnVelocityZ = getRandomF (getWord ($TSEmitter[%i, "minVelocity"], 2), getWord ($TSEmitter[%i, "maxVelocity"], 2));
		%InitScaleX     = getRandomF (getWord ($TSEmitter[%i, "initScaleMin"], 0), getWord ($TSEmitter[%i, "initScaleMax"], 0));
		%InitScaleY     = getRandomF (getWord ($TSEmitter[%i, "initScaleMin"], 1), getWord ($TSEmitter[%i, "initScaleMax"], 1));
		%InitScaleZ     = getRandomF (getWord ($TSEmitter[%i, "initScaleMin"], 2), getWord ($TSEmitter[%i, "initScaleMax"], 2));
		%EndScaleX      = getRandomF (getWord ($TSEmitter[%i, "endScaleMin"], 0), getWord ($TSEmitter[%i, "endScaleMax"], 0));
		%EndScaleY      = getRandomF (getWord ($TSEmitter[%i, "endScaleMin"], 1), getWord ($TSEmitter[%i, "endScaleMax"], 1));
		%EndScaleZ      = getRandomF (getWord ($TSEmitter[%i, "endScaleMin"], 2), getWord ($TSEmitter[%i, "endScaleMax"], 2));
		
		MM_BuildPreview.spawnParticle
		(
			$TSEmitter[%i, "type"],
			%SpawnPosX SPC %SpawnPosY SPC %SpawnPosZ,
			$TSEmitter[%i, "lifeTime"],
			%SpawnVelocityX SPC %SpawnVelocityY SPC %SpawnVelocityZ,
			%InitScaleX SPC %InitScaleY SPC %InitScaleZ,
			%EndScaleX SPC %EndScaleY SPC %EndScaleZ,
			$TSEmitter[%i, "initAlpha"],
			$TSEmitter[%i, "endAlpha"],
			$TSEmitter[%i, "color"]
		);
	}
	
	cancel (%this.handleEmittersSchedule);
	%this.handleEmittersSchedule = %this.schedule (32, HandleEmitters);
}

function MM_BuildPreview::LoadBLS (%this, %idx)
{
	for (%i = 0; %i < 1024; %i++)
	{
		%line = $TSBrickLine[%idx];
		if (%idx >= $TSBrickCount)
			return;
		
		// Read brick data
		%pos         = $TSBrickPos[%idx];
		%angId       = getWord (%line, 3);
		%isBaseplate = getWord (%line, 4);
		%color       = $colorTranslation[getWord (%line, 5)];
		%printName   = getWord (%line, 6);
		%colorFX     = getWord (%line, 7);
		%shapeFX     = getWord (%line, 8);
		%rayCasting  = getWord (%line, 9);
		%collision   = getWord (%line, 10);
		%rendering   = getWord (%line, 11);
		
		if (%rendering == 0)
		{
			%idx++;
			continue;
		}
		
		// Attempt to find the brick file for this brick
		%uiName    = $TSBrickBrickFile[%idx];
		%brickFile = "";
		if ($Cache::BuildPreview::BrickFile[%uiName] $= "")
		{
			for (%j = 0; %j < 200; %j++)
			{
				%fnTry = lookupFileNameForUIName (%uiName, %j);
				
				if (%fnTry $= "")
					break;
				
				if (fileExt (%fnTry) !$= ".blb")
					continue;
				
				%brickFile = %fnTry;
				break;
			}
			
			if (%brickFile $= "")
			{
				$Cache::BuildPreview::BrickFile[%uiName] = "FAIL";
				warn ("WARNING: MM_BuildPreview::loadBLS() - Unable to find brick file for \"" @ %uiName @ "\"");
				%idx++;
				continue;
			}
			
			$Cache::BuildPreview::BrickFile[%uiName] = %fnTry;
		}
		else if ($Cache::BuildPreview::BrickFile[%uiName] $= "FAIL")
		{
			%idx++;
			continue;
		}
		
		%brickFile = $Cache::BuildPreview::BrickFile[%uiName];
		
		if (%printName !$= "")
		{
			if ($Cache::BuildPreview::PrintFile[%printName] $= "")
			{
				%printName = lookupFileNameForUIName ("PRINT_" @ %printName);
				if (%printName $= "")
					$Cache::BuildPreview::PrintFile[%printName] = "FAIL";
				else
					$Cache::BuildPreview::PrintFile[%printName] = %printName;
			}
			%printName = $Cache::BuildPreview::PrintFile[%printName];
			if (%printName $= "FAIL")
				%printName = "";
		}
		
		%bName = "b" @ %idx;
		
		// Configure the brick
		MM_BuildPreview.addBrick                 (%bName, %brickFile);
		MM_BuildPreview.setBrickTransform        (%bName, %pos, 0);
		MM_BuildPreview.setBrickAngle            (%bName, %angId);
		MM_BuildPreview.setBrickColor            (%bName, %color);
		MM_BuildPreview.setBrickPrintTexture     (%bName, %printName);
		%idx++;
	}
	
	cancel (%this.loadBricksSchedule);
	%this.loadBricksSchedule = %this.schedule (64, LoadBLS, %idx);
}

function MM_BuildPreview::LoadBRLS (%this, %idx)
{
	for (%i = 0; %i < 1024; %i++)
	{
		%line = $TSBrickLine[%idx];
		if (%idx >= $TSBrickCount)
			return;
		
		%brickFile = $TSBrickBrickFile[%idx];
		
		// Read brick data
		%pos         = $TSBrickPos[%idx];
		%angId       = getWord (%line, 3);
		%isBaseplate = getWord (%line, 4);
		%color       = $colorTranslation[getWord (%line, 5)];
		%printName   = getWord (%line, 6);
		%colorFX     = getWord (%line, 7);
		%shapeFX     = getWord (%line, 8);
		%rayCasting  = getWord (%line, 9);
		%collision   = getWord (%line, 10);
		%rendering   = getWord (%line, 11);
		
		%bName = "b" @ %idx;
		
		// Configure the brick
		MM_BuildPreview.addBrick                 (%bName, %brickFile);
		MM_BuildPreview.setBrickTransform        (%bName, %pos, 0);
		MM_BuildPreview.setBrickAngle            (%bName, %angId);
		MM_BuildPreview.setBrickColor            (%bName, %color);
		MM_BuildPreview.setBrickPrintTexture     (%bName, "base/data/shapes/brickSIDE.png");
		%idx++;
	}
	
	cancel (%this.loadBricksSchedule);
	%this.loadBricksSchedule = %this.schedule (64, LoadBRLS, %idx);
}

function MM_BuildPreview::cleanupMemory (%this)
{
	cancel (%this.loadBricksSchedule);
	cancel (%this.handleEmittersSchedule);
	deleteVariables ("$TS*");
	%this.clearSky ();
	%this.clearCameraSequences ();
	%this.clearBricks ();
	%this.clearShapes ();
	%this.clearParticles ();
}

function MM_BuildPreview::loadBlocklandSave2 (%this, %map, %file)
{
	%file = "saves/" @ %map @ "/" @ %file @ ".bls";
	
	// Clear everything else
	%this.CancelLoad ();
	%this.clearBricks ();
	%this.clearShapes ();
	%this.clearParticles ();
	
	// Load the save
	%error = %this.loadTheBlocklandSave (%file);
	error ("Got error " @ %error);
	
	// Default skies
	%this.skies[0] = ("Add-Ons/Sky_Blue2/Blue2.atmosphere") NL ("Add-Ons/Sky_Blue2/Blue2.dml") NL "Blue2" NL "1";
	%this.skies[1] = ("Add-Ons/Sky_Spooky1/Spooky1.atmosphere") NL ("Add-Ons/Sky_Spooky1/Spooky1.dml") NL "Spooky1" NL "1";
	%this.skies[2] = ("Add-Ons/Sky_Skylands/Skylands.atmosphere") NL ("Add-Ons/Sky_Skylands/Skylands.dml") NL "Skylands" NL "1";
	%this.skies[3] = ("Add-Ons/Sky_Sunset/Sunset.atmosphere") NL ("Add-Ons/Sky_Sunset/Sunset.dml") NL "Sunset" NL "1";
	%this.skyCount = 4;
	
	// Set defaults
	%this.defaultOrbitDist = 82.2878;
	%this.defaultPosition  = "0 0 0";
	%this.defaultRotation  = "0.36 0 -2.05267";
	%this.defaultOrbitPos  = "0 0 0";
	%this.resetView (0);
	
	//%this.addShape ("groundPlane", "Add-Ons/Client_MainMenuBuildShowcase/models/groundPlane.dts");
	//%this.setShapeTransform ("groundPlane", "0 0 -4.45");
	//%this.LoadRandomGround ();
	%this.LoadRandomSky ();
	
	%this.HandleEmitters ();
	%this.setGlobalSpinSpeed (0.05);
}

function MM_BuildPreview::loadBlocklandSave (%this, %map, %file)
{
	%file = "saves/" @ %map @ "/" @ %file @ ".bls";
	
	%this.CancelLoad ();
	%this.clearBricks ();
	%this.clearShapes ();
	%this.clearParticles ();
	
	// Clear our cache
	deleteVariables ("$Cache::BuildPreview::*");
	
	// Reset ourselves
	%this.skyCount = 0;
	
	// Open it for read
	%SO = new FileObject();
	if (!%SO.openForRead(%file))
	{
		error("ERROR: MM_BuildPreview::loadBlocklandSave() - Failed to open \"" @ %file @ "\"");
		%SO.delete ();
		return;
	}
	
	// Read header
	%SO.readLine ();
	%descLineCount = %SO.readLine ();
	
	// Read the description (we don't need it)
	for (%i = 0; %i < %descLineCount; %i++)
		%SO.readLine ();
	
	// Read colorset
	for (%i = 0; %i < 64; %i++)
		$colorTranslation[%i] = %SO.readLine ();
	
	// Read 'LINECOUNT'
	%lineCount = %SO.readLine ();
	if (getWord (%lineCount, 0) !$= "Linecount")
	{
		error ("ERROR: MM_BuildPreview::loadBlocklandSave() - Invalid BLS file!");
		%SO.close ();
		%SO.delete ();
		return;
	}
	
	%this.clearCameraSequences ();
	%this.defaultOrbitPos = "0 0 0";
	%this.defaultPosition = "0 0 0";
	
	$TSBrickPosX    = 0;
	$TSBrickPosY    = 0;
	$TSBrickPosZ    = 0;
	$TSBrickCount   = 0;
	$TSTotalBricks  = 0;
	$TSEmitterCount = 0;
	$TSShapeCount   = 0;
	
	// Read the rest
	while (!%SO.isEOF ())
	{
		%line = trim (%SO.readLine ());
		
		// Non-brick line
		if (getSubStr (%line, 0, 2) $= "+-")
		{
			%brickIndex = $TSBrickPos - 1;
			
			// Determine what to do here
			switch$(firstWord (%line))
			{
				case "+-LIGHT":
//				{
					
//					break;
//				}
				case "+-EMITTER":
//				{
					
//					break;
//				}
				case "+-EVENT":
//				{
					
//					break;
//				}
				case "+-ITEM":
//				{
					
//					break;
//				}
				case "+-VEHICLE":
//				{
					
//					break;
//				}
			}
			
			continue;
		}
		
		%uiName = getSubStr (%line, 0, strPos (%line, "\""));
		%line   = getSubStr (%line, strPos (%line, "\"") + 2, strLen (%line));
		
		// Read brick data
		%pos         = getWords (%line, 0, 2);
		%angId       = getWord (%line, 3);
		%isBaseplate = getWord (%line, 4);
		%color       = $colorTranslation[getWord (%line, 5)];
		%printName   = getWord (%line, 6);
		%colorFX     = getWord (%line, 7);
		%shapeFX     = getWord (%line, 8);
		%rayCasting  = getWord (%line, 9);
		%collision   = getWord (%line, 10);
		%rendering   = getWord (%line, 11);
		
		$TSTotalBricks++;
		$TSBrickPosX += getWord (%pos, 0);
		$TSBrickPosY += getWord (%pos, 1);
		$TSBrickPosZ += getWord (%pos, 2);
		
		//if (atof(getWord (%color, 3)) != 1)
			//continue;
		
		$TSBrickCount++;
		$TSBrickPos[$TSBrickCount - 1]       = %pos;
		$TSBrickLine[$TSBrickCount - 1]      = %line;
		$TSBrickBrickFile[$TSBrickCount - 1] = %uiName;
	}
	
	if ($TSBrickCount > 0)
	{
		$TSBrickPosX /= $TSTotalBricks;
		$TSBrickPosY /= $TSTotalBricks;
		$TSBrickPosZ /= $TSTotalBricks;
		
		for (%i = 0; %i < $TSBrickCount; %i++)
		{
			%pos   = $TSBrickPos[%i];
			%bName = "b" @ %i;
			
			$TSBrickPos[%i] = (getWord (%pos, 0) - $TSBrickPosX) SPC (getWord (%pos, 1) - $TSBrickPosY) SPC (getWord (%pos, 2) - $TSBrickPosZ);
		}
	}
	
	// Done with the file
	%SO.close();
	%SO.delete();
	
	// Default skies
	%this.skies[0] = ("Add-Ons/Sky_Blue2/Blue2.atmosphere") NL ("Add-Ons/Sky_Blue2/Blue2.dml") NL "Blue2" NL "1";
	%this.skies[1] = ("Add-Ons/Sky_Spooky1/Spooky1.atmosphere") NL ("Add-Ons/Sky_Spooky1/Spooky1.dml") NL "Spooky1" NL "1";
	%this.skies[2] = ("Add-Ons/Sky_Skylands/Skylands.atmosphere") NL ("Add-Ons/Sky_Skylands/Skylands.dml") NL "Skylands" NL "1";
	%this.skies[3] = ("Add-Ons/Sky_Sunset/Sunset.atmosphere") NL ("Add-Ons/Sky_Sunset/Sunset.dml") NL "Sunset" NL "1";
	%this.skyCount = 4;
	
	// Set defaults
	%this.defaultOrbitDist = 82.2878;
	%this.defaultPosition  = "0 0 0";
	%this.defaultRotation  = "0.36 0 -2.05267";
	%this.defaultOrbitPos  = "0 0 0";
	%this.resetView (0);
	
	//%this.addShape ("groundPlane", "Add-Ons/Client_MainMenuBuildShowcase/models/groundPlane.dts");
	//%this.setShapeTransform ("groundPlane", "0 0 -4.45");
	//%this.LoadRandomGround ();
	%this.LoadRandomSky ();
	
	if (!%dontLoadBricks)
		%this.LoadBLS (0);
	
	%this.HandleEmitters ();
	%this.setGlobalSpinSpeed (0.05);
}

function MM_BuildPreview::loadBackgroundBuild (%this, %file, %dontLoadBricks)
{
	%file = "config/client/buildShowcase/builds/" @ fileBase (%file) @ ".blrs";
	
	if (!isFile (%file))
		%file = "Add-Ons/Client_MainMenuBuildShowcase/builds/" @ fileBase (%file) @ ".blrs";
	
	%this.CancelLoad ();
	if (!%dontLoadBricks)
	{
		%this.clearBricks ();
		%this.clearShapes ();
		%this.clearParticles ();
	}
	
	// Reset ourselves
	%this.skyCount = 0;
	
	%SO = new FileObject();
	if (!%SO.openForRead(%file))
	{
		error("ERROR: MM_BuildPreview::loadBackgroundBuild() - Failed to open \"" @ %file @ "\"");
		%SO.delete();
		return;
	}
	
	// Read header
	%SO.readLine ();
	%descLineCount = %SO.readLine ();
	
	// Read the description (we don't need it)
	for (%i = 0; %i < %descLineCount; %i++)
		%SO.readLine ();
	
	// Read colorset
	for (%i = 0; %i < 64; %i++)
		$colorTranslation[%i] = %SO.readLine ();
	
	// Read 'BEGIN'
	if (strPos (%SO.readLine (), "Begin") != 0)
	{
		error("ERROR: MM_BuildPreview::loadBackgroundBuild() - Invalid BLRS file!");
		%SO.close();
		%SO.delete();
		return;
	}
	
	%this.clearCameraSequences ();
	%this.defaultOrbitPos = "0 0 0";
	%this.defaultPosition = "0 0 0";
	
	$TSBrickPosX    = 0;
	$TSBrickPosY    = 0;
	$TSBrickPosZ    = 0;
	$TSBrickCount   = 0;
	$TSTotalBricks  = 0;
	$TSEmitterCount = 0;
	$TSShapeCount   = 0;
	
	// Read the rest
	while (!%SO.isEOF ())
	{
		%line = trim (%SO.readLine ());
		
		if (getField (%line, 0) $= "SET_NODE_COLOR")
		{
			%ObjName  = getField (%line, 1);
			%NodeName = getField (%line, 2);
			%Color    = getField (%line, 3);
			
			%this.setNodeColor (%ObjName, %NodeName, %Color);
			continue;
		}
		else if (getField (%line, 0) $= "SET_NODE_VISIBLE")
		{
			%ObjName  = getField (%line, 1);
			%NodeName = getField (%line, 2);
			%Color    = getField (%line, 3);
			
			%this.setNodeVisible (%ObjName, %NodeName, %Color);
			continue;
		}
		else if (getWord (%line, 0) $= "ALLOW_SKY")
		{
			%skyName      = getWord (%line, 1);
			%lightForward = getWord (%line, 2);
			
			if (isFile ("Add-Ons/Sky_" @ %skyName @ "/" @ %skyName @ ".atmosphere") && isFile ("Add-Ons/Sky_" @ %skyName @ "/" @ %skyName @ ".dml"))
			{
				%this.skies[%this.skyCount] = ("Add-Ons/Sky_" @ %skyName @ "/" @ %skyName @ ".atmosphere") NL ("Add-Ons/Sky_" @ %skyName @ "/" @ %skyName @ ".dml") NL %skyName NL %lightForward;
				%this.skyCount++;
			}
			else
			{
				warn("WARNING: MM_BuildPreview::loadBackgroundBuild() - Failed to find sky files for \"" @ %skyName @ "\".");
			}
			
			continue;
		}
		else if (getWord (%line, 0) $= "BEGIN_SEQUENCE")
		{
			%data = "BEGIN_SEQUENCE";

			while (!%SO.isEOF ())
			{
				%line = trim (%SO.readLine ());
				%done = false;
				
				switch$(firstWord (%line))
				{
					case "END_SEQUENCE":
						%data = %data NL %line;
						%done = true;
					default:
						%data = %data NL %line;
				}
				
				if (%done)
					break;
			}
			
			%this.parseCameraSequence (%data);
			continue;
		}
		else if (getWord (%line, 0) $= "CAMERA_DIST")
		{
			%this.defaultOrbitDist = removeWord (%line, 0);
			%this.resetView (0);
			continue;
		}
		else if (getWord (%line, 0) $= "CAMERA_POS")
		{
			%this.defaultPosition = removeWord (%line, 0);
			%this.resetView (0);
			continue;
		}
		else if (getWord (%line, 0) $= "CAMERA_ROT")
		{
			%this.defaultRotation = removeWord (%line, 0);
			%this.resetView (0);
			continue;
		}
		else if (getWord (%line, 0) $= "ORBIT_POS")
		{
			%this.defaultOrbitPos = removeWord (%line, 0);
			%this.resetView (0);
			continue;
		}
		else if (getWord (%line, 0) $= "PARTICLETYPE")
		{
			%textureName = getSubStr (removeWord (%line, 0), 0, strPos (removeWord (%line, 0), "\""));
			%line        = getSubStr (%line, strPos (%line, "\"") + 2, strLen (%line));
			%typeName    = getWord (%line, 0);
			%gravity     = getWord (%line, 1);
			%drag        = getWord (%line, 2);
			
			%this.createParticleType (%typeName, %textureName, %gravity, %drag);
			continue;
		}
		else if (getWord (%line, 0) $= "BEGIN_EMITTER")
		{
			%line = removeWord (%line, 0);
			$TSEmitterCount++;
			
			while (!%SO.isEOF ())
			{
				%line = trim (%SO.readLine ());
				%done = false;
				
				switch$(firstWord (%line))
				{
					case "TYPE":
						$TSEmitter[$TSEmitterCount - 1, "type"] = trim (removeWord (%line, 0));
					case "POS":
						$TSEmitter[$TSEmitterCount - 1, "pos"] = trim (removeWord (%line, 0));
					case "LIFETIME":
						$TSEmitter[$TSEmitterCount - 1, "lifeTime"] = trim (removeWord (%line, 0));
					case "VEL_MIN":
						$TSEmitter[$TSEmitterCount - 1, "minVelocity"] = trim (removeWord (%line, 0));
					case "VEL_MAX":
						$TSEmitter[$TSEmitterCount - 1, "maxVelocity"] = trim (removeWord (%line, 0));
					case "INIT_SCALE_MIN":
						$TSEmitter[$TSEmitterCount - 1, "initScaleMin"] = trim (removeWord (%line, 0));
					case "INIT_SCALE_MAX":
						$TSEmitter[$TSEmitterCount - 1, "initScaleMax"] = trim (removeWord (%line, 0));
					case "END_SCALE_MIN":
						$TSEmitter[$TSEmitterCount - 1, "endScaleMin"] = trim (removeWord (%line, 0));
					case "END_SCALE_MAX":
						$TSEmitter[$TSEmitterCount - 1, "endScaleMax"] = trim (removeWord (%line, 0));
					case "INIT_ALPHA":
						$TSEmitter[$TSEmitterCount - 1, "initAlpha"] = trim (removeWord (%line, 0));
					case "END_ALPHA":
						$TSEmitter[$TSEmitterCount - 1, "endAlpha"] = trim (removeWord (%line, 0));
					case "COLOR":
						$TSEmitter[$TSEmitterCount - 1, "color"] = trim (removeWord (%line, 0));
					case "SPAWN_OFFSET":
						$TSEmitter[$TSEmitterCount - 1, "spawnOffset"] = trim (removeWord (%line, 0));
					case "EJECT_PERIOD_MS":
						$TSEmitter[$TSEmitterCount - 1, "ejectPeriodMS"] = trim (removeWord (%line, 0));
					case "END_EMITTER":
						%done = true;
				}
				
				if (%done)
					break;
			}
			
			continue;
		}
		else if (getWord (%line, 0) $= "BEGIN_SHAPE")
		{
			%line = removeWord (%line, 0);
			$TSShapeCount++;
			
			while (!%SO.isEOF ())
			{
				%line = trim (%SO.readLine ());
				%done = false;
				
				switch$(firstWord (%line))
				{
					case "NAME":
						$TSShape[$TSShapeCount - 1, "name"] = trim (removeWord (%line, 0));
					case "MODEL":
						$TSShape[$TSShapeCount - 1, "model"] = trim (removeWord (%line, 0));
					case "POSITION":
						$TSShape[$TSShapeCount - 1, "pos"] = trim (removeWord (%line, 0));
					case "SCALE":
						$TSShape[$TSShapeCount - 1, "scale"] = trim (removeWord (%line, 0));
					case "ROTATION":
						$TSShape[$TSShapeCount - 1, "rotZ"] = trim (removeWord (%line, 0));
					case "ABS_POS":
						$TSShape[$TSShapeCount - 1, "absPos"] = trim (removeWord (%line, 0));
					case "END_SHAPE":
						%done = true;
				}
				
				if (%done)
					break;
			}
			
			%this.addShape ($TSShape[$TSShapeCount - 1, "name"], $TSShape[$TSShapeCount - 1, "model"]);
			%this.setShapeTransform ($TSShape[$TSShapeCount - 1, "name"], $TSShape[$TSShapeCount - 1, "pos"], $TSShape[$TSShapeCount - 1, "scale"], $TSShape[$TSShapeCount - 1, "rotZ"]);
			
			continue;
		}
		
		%brickFile = getSubStr (%line, 0, strPos (%line, "\""));
		%line      = getSubStr (%line, strPos (%line, "\"") + 2, strLen (%line));
		
		// Read brick data
		%pos         = getWords (%line, 0, 2);
		%angId       = getWord (%line, 3);
		%isBaseplate = getWord (%line, 4);
		%color       = $colorTranslation[getWord (%line, 5)];
		%printName   = getWord (%line, 6);
		%colorFX     = getWord (%line, 7);
		%shapeFX     = getWord (%line, 8);
		%rayCasting  = getWord (%line, 9);
		%collision   = getWord (%line, 10);
		%rendering   = getWord (%line, 11);
		
		$TSTotalBricks++;
		$TSBrickPosX += getWord (%pos, 0);
		$TSBrickPosY += getWord (%pos, 1);
		$TSBrickPosZ += getWord (%pos, 2);
		
		//if (atof(getWord (%color, 3)) != 1)
			//continue;
		
		$TSBrickCount++;
		$TSBrickPos[$TSBrickCount - 1]       = %pos;
		$TSBrickLine[$TSBrickCount - 1]      = %line;
		$TSBrickBrickFile[$TSBrickCount - 1] = %brickFile;
	}
	
	if ($TSBrickCount > 0)
	{
		$TSBrickPosX /= $TSTotalBricks;
		$TSBrickPosY /= $TSTotalBricks;
		$TSBrickPosZ /= $TSTotalBricks;
		
		for (%i = 0; %i < $TSBrickCount; %i++)
		{
			%pos   = $TSBrickPos[%i];
			%bName = "b" @ %i;
			
			$TSBrickPos[%i] = (getWord (%pos, 0) - $TSBrickPosX) SPC (getWord (%pos, 1) - $TSBrickPosY) SPC (getWord (%pos, 2) - $TSBrickPosZ);
		}
		
		for (%i = 0; %i < $TSEmitterCount; %i++)
		{
			%pos                  = $TSEmitter[%i, "pos"];
			$TSEmitter[%i, "pos"] = (getWord (%pos, 0) - $TSBrickPosX) SPC (getWord (%pos, 1) - $TSBrickPosY) SPC (getWord (%pos, 2) - $TSBrickPosZ);
		}
		
		for (%i = 0; %i < $TSShapeCount; %i++)
		{
			%isAlreadyAbs = $TSShape[%i, "absPos"];
			
			if (%isAlreadyAbs)
				continue;
			
			%pos                = $TSShape[%i, "pos"];
			$TSShape[%i, "pos"] = (getWord (%pos, 0) - $TSBrickPosX) SPC (getWord (%pos, 1) - $TSBrickPosY) SPC (getWord (%pos, 2) - $TSBrickPosZ);
			%this.setShapeTransform ($TSShape[%i, "name"], $TSShape[%i, "pos"], $TSShape[%i, "scale"], $TSShape[%i, "rotZ"]);
		}
	}
	
	%SO.close();
	%SO.delete();
	
	//%this.addShape ("groundPlane", "Add-Ons/Client_MainMenuBuildShowcase/models/groundPlane.dts");
	//%this.setShapeTransform ("groundPlane", "0 0 -4.45");
	//%this.LoadRandomGround ();
	%this.LoadRandomSky ();
	
	if (!%dontLoadBricks)
		%this.LoadBRLS (0);
	
	%this.HandleEmitters ();
	%this.setGlobalSpinSpeed (0.05);
}

function MM_BuildPreview::onResetViewAny (%this)
{
	%this.overrideFOV = 0;
}

function MM_BuildPreview::onResetView (%this)
{
	%this.setGlobalSpinSpeed (0.05);
}

function MM_BuildPreview::onRender (%this)
{
	if (!$pref::Client::BuildShowcase::Enabled)
	{
		%this.updateBuildShowcase ();
		return;
	}
	
	if (%this.getBrickCount () == 0 && !isObject (ServerConnection))
	{
		%this.LoadRandomBuild();
	}
	
	%this.setGlobalSpinSpeed (0.05);
}

function MM_BuildPreview::onMouseDown (%this)
{
	if (isEventPending (%this.refocusSchedule) && !%this.refocusScheduleFadeOut)
	{
		cancel (%this.refocusSchedule);
		return;
	}
	
	%this.refocusScheduleFadeOut = true;
	cancel (%this.refocusSchedule);
	%this.refocusSchedule = %this.schedule (1000, setFocus, 0.4);
}

function MM_BuildPreview::onAlwaysMouseUp (%this)
{
	if (isEventPending (%this.refocusSchedule) && %this.refocusScheduleFadeOut)
	{
		cancel (%this.refocusSchedule);
		return;
	}
	
	%this.refocusScheduleFadeOut = false;
	cancel (%this.refocusSchedule);
	%this.refocusSchedule = %this.schedule (1000, setFocus, 1);
}

function MM_BuildPreview::onControlStart (%this)
{
	cancel (%this.refocusSchedule);
	%this.setFocus (0, 400);
	%this.overrideFOV = $pref::Player::defaultFov;
}

function MM_BuildPreview::onControlEnd (%this)
{
	cancel (%this.refocusSchedule);
	%this.setFocus (1);
}

function MM_BuildPreview::setFocus (%this, %amount, %speed)
{
	if (%this.focus == %amount)
		return;
	
	if (%speed $= "")
		%speed = 2000;
	
	%this.focus = %amount;
	%elemCount = 0;
	for (%i = 0; %i < MainMenuGui.getCount (); %i++)
	{
		%object = MainMenuGui.getObject (%i);
		
		if (%object.getClassName () $= "GuiBitmapButtonCtrl" || (%object.getClassName () $= "GuiBitmapCtrl" && %object.getName () !$= "MM_AuthBar"))
		{
			if (%object.originalColor $= "")
			{
				%object.originalColor = %object.getColor ();
			}
			if (%object.originalCommand $= "")
			{
				%object.originalCommand = %object.command;
			}
			
			if (%object.getClassName () $= "GuiBitmapButtonCtrl")
			{
				if (%amount == 1)
				{
					%object.command = %object.originalCommand;
				}
				else
				{
					%object.command = "MM_BuildPreview.setFocus (1);" @ %object.originalCommand;
				}
			}
			
			GlobalObjectAnimator.cancelObjectAnimations (%object);
			GlobalObjectAnimator.smoothRecolor (0, %speed, %object, 255 * getWord (%object.originalColor, 0), 255 * getWord (%object.originalColor, 1), 255 * getWord (%object.originalColor, 2), 255 * %amount * getWord (%object.originalColor, 3), "", 0, $Math::Lerp::Method::CubicOut);
		}
	}
	
	if (%amount == 0)
	{
		// Fade buttons out
		MM_BuildPreviewFreeCamTip.start = 0;
		MM_BuildPreviewFreeCamTip.end   = 255;
		
		GlobalObjectAnimator.cancelObjectAnimations (MM_BuildPreviewFreeCamTip);
		GlobalObjectAnimator.cancelObjectAnimations (MM_BuildPreviewCrosshair);
		GlobalObjectAnimator.smoothCustomCall (0, %speed / 3, MM_BuildPreviewFreeCamTip, "MM_BuildPreviewTickTextAnim");
		GlobalObjectAnimator.smoothRecolor (0, 100, MM_BuildPreviewCrosshair, 255, 255, 255, 255);
	}
	else if (%amount == 1)
	{
		// Fade buttons in
		MM_BuildPreviewFreeCamTip.start = 255;
		MM_BuildPreviewFreeCamTip.end   = 0;
		
		GlobalObjectAnimator.cancelObjectAnimations (MM_BuildPreviewFreeCamTip);
		GlobalObjectAnimator.cancelObjectAnimations (MM_BuildPreviewCrosshair);
		GlobalObjectAnimator.smoothCustomCall (0, %speed / 3, MM_BuildPreviewFreeCamTip, "MM_BuildPreviewTickTextAnim");
		GlobalObjectAnimator.smoothRecolor (0, 100, MM_BuildPreviewCrosshair, 255, 255, 255, 0);
	}
	
	GlobalObjectAnimator.pushEasyGroup ();
}