function isBlocklandRebuilt ()
{
	return false;
}

if (!isBlocklandRebuilt () && atof ($Version) < 1.8)
{
	error ("ERROR: This add-on only works with Blockland Rebuilt v1.8 and newer.");
	return;
}

//function cl_icons()
//{
//	exec("add-ons/client_realbrickicons/client.cs");
//}

// $Pref::Client::UI::RealBrickIcons::ReplaceConditions VALUES:
//   0 - Disabled; Never replace icons
//   1 - Only replace icons with 3D ones if the icon is missing
//   2 - Replace ALL icons

// Setup default values
if ($Pref::Client::UI::RealBrickIcons::ReplaceConditions $= "")
	$Pref::Client::UI::RealBrickIcons::ReplaceConditions = 1;

if ($Pref::Client::UI::RealBrickIcons::PrintTexture $= "")
	$Pref::Client::UI::RealBrickIcons::PrintTexture = "Add-Ons/Print_2x2r_Default/prints/vent.png";

// Begin package
package RealBrickIconsPackage
{
	function BSD_LoadBricks ()
	{
		deleteVariables ("$BSD_RealBrickIcons_*");
		$BSD_RealBrickIcons_Count = 0;
		Parent::BSD_LoadBricks ();
	}
	function BrickSelectorDlg::onWake (%this)
	{
		Parent::onWake (%this);
		
		%color = getColorIDTable ($currSprayCanIndex);
		%print = getPrintTexture ($PSD_LastSelectedPrint);
		for (%i = 0; %i < $BSD_RealBrickIcons_Count; %i++)
		{
			%uiObj = $BSD_RealBrickIcons_List[%i];
			
			if (!isObject (%uiObj))
				continue;
			
			//%uiObj.setBrickPrintTexture ("brick", %print);
			//%uiObj.setBrickColor ("brick", %color);
			%uiObj.setBrickPrintTexture ("brick", $Pref::Client::UI::RealBrickIcons::PrintTexture);
			%uiObj.setBrickColor ("brick", "1 1 1 1");
		}
	}
	function BSD_CreateBrickButton (%data)
	{
		%catName    = %data.category;
		%subCatName = %data.subCategory;
		%catObj     = BSD_findCategory (%catName);
		%subCatObj  = BSD_findSubCategory (%catObj, %subCatName);
		
		if (%catObj == 0 || %subCatObj == 0)
		{
			error ("ERROR: BSD_CreateBrickButton - Couldnt find category objects");
			return;
		}
		
		%brickName = %data.uiName;
		%brickIcon = %data.iconName;
		%brickFile = %data.brickFile;
		%brickVol  = %data.brickSizeX * %data.brickSizeY * %data.brickSizeZ;
		
		if (%brickName $= "")
		{
			%brickName = "No Name";
		}
		
		%replaceIcon = ($Pref::Client::UI::RealBrickIcons::ReplaceConditions == 2);
		
		if (!isFile (%brickIcon))
		{
			%brickIcon = "base/client/ui/brickIcons/unknown";
			
			// Icon is missing for this brick -- Replace with 3D representation
			if ($Pref::Client::UI::RealBrickIcons::ReplaceConditions == 1)
				%replaceIcon = true;
		}
		
		%box = %catObj.box;
		%x   = ((%subCatObj.numBrickButtons % 6) * 97) + 18;
		%y   = (mFloor (%subCatObj.numBrickButtons / 6) * 97) + %subCatObj.startHeight + 18;
		
		%subCatObj.numBrickButtons += 1;
		
		// Create the icon background
		%newIconBG = new GuiBitmapCtrl ()
		{
			profile    = "BlockDefaultProfile";
			position   = %x SPC %y;
			extent     = "96 96";
			bitmap     = "base/client/ui/brickicons/brickiconbg";
			keepCached = 1;
		};
		%box.add (%newIconBG);
		
		// Now the actual icon itself
		if (%replaceIcon)
		{
			// Calculate camera position and orbit distance
			%biggest = %data.brickSizeX;
			if (%data.brickSizeY > %biggest)
				%biggest = %data.brickSizeY;
			if (%data.brickSizeZ > %biggest)
				%biggest = %data.brickSizeZ;
			
			%orbitDist   = 2 + (18 * %biggest / 64);
			%orbitOffset = VectorLerp ($Math::Lerp::Method::Linear, "0 0 0", "0 0 1", %biggest / 64);
			
			%newScene = new GuiCustomSceneCtrl ()
			{
				canSaveDynamicFields  = "0";
				applyFilterToChildren = "1";
				profile               = "GuiDefaultProfile";
				horizSizing           = "right";
				vertSizing            = "bottom";
				position              = (%x + 3) SPC (%y + 3);
				extent                = "90 90";
//				position              = %x SPC %y;
//				extent                = "96 96";
				minExtent             = "1 1";
				canSave               = "1";
				visible               = "1";
				hovertime             = "1000";
				cameraPos             = "0 0 0";
				cameraZRot            = "0";
				forceFOV              = "51";
				lightDirection        = "0.280166 -0.769751 0.573577";
				lightColor            = "0.852 0.852 0.852 1.0";
				ambientColor          = "0.35 0.35 0.35 1.0";
				lightForward          = "0";
				moveSpeed             = "20";
				maxMoveSpeed          = "40";
				canMoveCamera         = "0";
				canRotateCamera       = "0";
				canControl            = "0";
				defaultPosition       = "0 0 0";//%orbitOffset;
				defaultRotation       = "0.436332 0 3.92699";
				defaultOrbitPos       = "0 0 0";
				defaultOrbitDist      = %orbitDist;
				minOrbitDist          = "2";
				maxOrbitDist          = "20";
				desiredFOV            = "0";
				overrideFOV           = "0";
				farPlane              = "900";
				renderSky             = "0";
				renderFog             = "0";
				renderSkyBottom       = "0";
				modulateSkyColor      = "0";
				useSkyTextures        = "0";
				skyColor              = "126 193 236 255";
				fogColor              = "128 128 128 255";
				timeBeforeReset       = "-1";
				useShaders            = "0";
				data                  = %data;
			};
			
			// Add this to a list
			$BSD_RealBrickIcons_List[$BSD_RealBrickIcons_Count] = %newScene.getId ();
			$BSD_RealBrickIcons_Count++;
			
			// Configure the brick
			%newScene.addBrick ("brick", %brickFile);
			%newScene.setBrickPrintTexture ("brick", $Pref::Client::UI::RealBrickIcons::PrintTexture);
			%newScene.setBrickColor ("brick", "1 1 1 1");//getColorIDTable ($currSprayCanIndex));
			
			// Angle correctly
			if (%data.brickSizeX > %data.brickSizeY)
				%newScene.setBrickAngle ("brick", 1);
			
			// Done with it -- add it in the icon's place.
			%box.add (%newScene);
		}
		else
		{
			%newIcon = new GuiBitmapCtrl ()
			{
				profile    = "BlockDefaultProfile";
				position   = %x SPC %y;
				extent     = "96 96";
				keepCached = 1;
				bitmap     = %brickIcon;
			};
			
			%box.add (%newIcon);
		}
		
		// Create the active button
		%newActive = new GuiBitmapCtrl ("")
		{
			profile    = "BlockDefaultProfile";
			position   = %x SPC %y;
			extent     = "96 96";
			visible    = 0;
			bitmap     = "base/client/ui/brickicons/brickIconActive";
			keepCached = 1;
		};
		%box.add (%newActive);
		$BSD_activeBitmap[%data] = %newActive;
		
		// Create the icon button
		%newIconButton = new GuiBitmapButtonCtrl ("")
		{
			profile    = "BlockButtonProfile";
			position   = %x SPC %y;
			extent     = "96 96";
			command    = "BSD_ClickIcon(" @ %data @ ");";
			altCommand = "BSD_RightClickIcon(" @ %data @ ");";
			bitmap     = "base/client/ui/brickicons/brickIconBtn";
			class      = (isObject (%newScene) ? "BSD_BrickButton" : "");
			scene      = %newScene;
		};
		%box.add (%newIconButton);
		%newIconButton.setText (" ");
		
		// Create the label
		%newLabel = new GuiTextCtrl ("");
		%box.add (%newLabel);
		%w = 96;
		%h = 18;
		%x = %x;
		%y = (%y + 96) - %h;
		%newLabel.resize (%x, %y, %w, %h);
		%newLabel.setProfile (HUDBSDNameProfile);
		%newLabel.setText (%brickName);
	}
	function PSD_click (%number)
	{
		Parent::PSD_click (%number);
		$PSD_LastSelectedPrint = %number;
	}
	function BSD_InventoryButtonIcon::setBitmap (%this, %bmp)
	{
		Parent::setBitmap (%this, %bmp);
		
		if (!isObject (%this.scene))
			return;
		
		%index = %this.index;
		%data  = $BSD_InvData[%index];
		
		// Setup visibility
		if (isObject (%data) && strPos (%this.bitmap, "unknown") != -1)
		{
			%this.scene.setVisible (true);
			Parent::setBitmap (%this, "");
			%this.scene.clearBricks ();
			%this.scene.addBrick ("brick", %data.brickFile);
			%this.scene.setBrickPrintTexture ("brick", $Pref::Client::UI::RealBrickIcons::PrintTexture);
			%this.scene.setBrickColor ("brick", "1 1 1 1");
			
			// Calculate camera position and orbit distance
			%biggest = %data.brickSizeX;
			if (%data.brickSizeY > %biggest)
				%biggest = %data.brickSizeY;
			if (%data.brickSizeZ > %biggest)
				%biggest = %data.brickSizeZ;
			
			%orbitDist = 2 + (18 * %biggest / 64);
			
			%this.scene.defaultOrbitDist = %orbitDist;
			%this.scene.setOrbitDist (%orbitDist);
		}
		else
		{
			%this.scene.setVisible (false);
		}
	}
	function BSD_CreateInventoryButtons ()
	{
		Parent::BSD_CreateInventoryButtons ();
		
		for (%i = 0; %i < $BSD_NumInventorySlots; %i++)
		{
			%obj = $BSD_InvIcon[%i];
			
			if (!isObject (%obj))
				continue;
			
			// Set this icon's new namespace
			%obj.setScriptClassName ("BSD_InventoryButtonIcon");
			
			%newScene = new GuiCustomSceneCtrl ()
			{
				canSaveDynamicFields  = "0";
				applyFilterToChildren = "1";
				profile               = "GuiDefaultProfile";
				horizSizing           = "right";
				vertSizing            = "bottom";
				position              = "0 0";
				extent                = %obj.getExtent ();
				minExtent             = "1 1";
				canSave               = "1";
				visible               = "0";
				hovertime             = "1000";
				cameraPos             = "0 0 0";
				cameraZRot            = "0";
				forceFOV              = "51";
				lightDirection        = "0.280166 -0.769751 0.573577";
				lightColor            = "0.852 0.852 0.852 1.0";
				ambientColor          = "0.35 0.35 0.35 1.0";
				lightForward          = "0";
				moveSpeed             = "20";
				maxMoveSpeed          = "40";
				canMoveCamera         = "0";
				canRotateCamera       = "0";
				canControl            = "0";
				defaultPosition       = "0 0 0";//%orbitOffset;
				defaultRotation       = "0.436332 0 3.92699";
				defaultOrbitPos       = "0 0 0";
				defaultOrbitDist      = %orbitDist;
				minOrbitDist          = "2";
				maxOrbitDist          = "20";
				desiredFOV            = "0";
				overrideFOV           = "0";
				farPlane              = "900";
				renderSky             = "0";
				renderFog             = "0";
				renderSkyBottom       = "0";
				modulateSkyColor      = "0";
				useSkyTextures        = "0";
				skyColor              = "126 193 236 255";
				fogColor              = "128 128 128 255";
				timeBeforeReset       = "-1";
				useShaders            = "0";
			};
			
			%obj.add (%newScene);
			$BSD_InvScene[%i] = %newScene;
			%obj.index        = %i;
			%obj.scene        = %newScene;
		}
	}
	function HUD_BrickInventoryIcon::setBitmap (%this, %bmp)
	{
		Parent::setBitmap (%this, %bmp);
		
		if (!isObject (%this.scene))
			return;
		
		%index = %this.index;
		%data  = $InvData[%index];
		
		// Setup visibility
		if (isObject (%data) && strPos (%this.bitmap, "unknown") != -1)
		{
			%this.scene.setVisible (true);
			Parent::setBitmap (%this, "");
			%this.scene.clearBricks ();
			%this.scene.addBrick ("brick", %data.brickFile);
			%this.scene.setBrickPrintTexture ("brick", $Pref::Client::UI::RealBrickIcons::PrintTexture);
			%this.scene.setBrickColor ("brick", getColorIDTable ($currSprayCanIndex));
			
			// Calculate camera position and orbit distance
			%biggest = %data.brickSizeX;
			if (%data.brickSizeY > %biggest)
				%biggest = %data.brickSizeY;
			if (%data.brickSizeZ > %biggest)
				%biggest = %data.brickSizeZ;
			
			%orbitDist = 2 + (18 * %biggest / 64);
			
			%this.scene.defaultOrbitDist = %orbitDist;
			%this.scene.setOrbitDist (%orbitDist);
		}
		else
		{
			%this.scene.setVisible (false);
		}
	}
	function HUD_BrickInventoryIcon::setColor (%this, %color)
	{
		Parent::setColor (%this, %color);
		
		if (!isObject (%this.scene) || !%this.scene.isVisible ())
			return;
		
		%this.scene.setBrickColor ("brick", %color);
	}
	function PlayGui::createInvHud (%this)
	{
		Parent::createInvHud (%this);
		
		for (%i = 0; %i < $BSD_NumInventorySlots; %i++)
		{
			%obj = $HUD_BrickIcon[%i];
			
			if (!isObject (%obj))
				continue;
			
			// Set this icon's new namespace
			%obj.setScriptClassName ("HUD_BrickInventoryIcon");
			
			%newScene = new GuiCustomSceneCtrl ()
			{
				canSaveDynamicFields  = "0";
				applyFilterToChildren = "1";
				profile               = "GuiDefaultProfile";
				horizSizing           = "right";
				vertSizing            = "bottom";
				position              = "0 0";
				extent                = %obj.getExtent ();
				minExtent             = "1 1";
				canSave               = "1";
				visible               = "0";
				hovertime             = "1000";
				cameraPos             = "0 0 0";
				cameraZRot            = "0";
				forceFOV              = "51";
				lightDirection        = "0.280166 -0.769751 0.573577";
				lightColor            = "0.852 0.852 0.852 1.0";
				ambientColor          = "0.35 0.35 0.35 1.0";
				lightForward          = "0";
				moveSpeed             = "20";
				maxMoveSpeed          = "40";
				canMoveCamera         = "0";
				canRotateCamera       = "0";
				canControl            = "0";
				defaultPosition       = "0 0 0";//%orbitOffset;
				defaultRotation       = "0.436332 0 3.92699";
				defaultOrbitPos       = "0 0 0";
				defaultOrbitDist      = %orbitDist;
				minOrbitDist          = "2";
				maxOrbitDist          = "20";
				desiredFOV            = "0";
				overrideFOV           = "0";
				farPlane              = "900";
				renderSky             = "0";
				renderFog             = "0";
				renderSkyBottom       = "0";
				modulateSkyColor      = "0";
				useSkyTextures        = "0";
				skyColor              = "126 193 236 255";
				fogColor              = "128 128 128 255";
				timeBeforeReset       = "-1";
				useShaders            = "0";
			};
			
			%obj.add (%newScene);
			$HUD_BrickScene[%i] = %newScene;
			%obj.index          = %i;
			%obj.scene          = %newScene;
		}
	}
};

// Run the package
activatePackage (RealBrickIconsPackage);

// Functions for special 
function BSD_BrickButton::onMouseEnter (%this)
{
	if (!isObject (%this.scene))
		return;
	
	%this.scene.setGlobalSpinSpeed (1);
}

function BSD_BrickButton::onMouseLeave (%this)
{
	if (!isObject (%this.scene))
		return;
	
	%this.scene.setGlobalSpinSpeed (0);
	%this.scene.resetView (0);
}

function BSD_EvalScenes (%eval)
{
	for (%i = 0; %i < $BSD_RealBrickIcons_Count; %i++)
	{
		%uiObj = $BSD_RealBrickIcons_List[%i];
		
		if (!isObject (%uiObj))
			continue;
		
		eval (%eval);
	}
}