//#############################################################################
//#
//#	Return to Blockland - Version 4
//#
//#	-------------------------------------------------------------------------
//#
//#		$Rev: 259 $
//#		$Date: 2011-11-05 00:41:50 +0000 (Sat, 05 Nov 2011) $
//#		$Author: Ephialtes $
//#		$URL: http://svn.returntoblockland.com/code/trunk/modules/client/options.cs $
//#
//#		$Id: options.cs 259 2011-11-05 00:41:50Z Ephialtes $
//#
//#	-------------------------------------------------------------------------
//#
//#	Modules / Client / Options
//#
//#############################################################################
//Register that this module has been loaded
$RTB::Modules::Client::Options = 1;

//*********************************************************
//* Variable Declarations
//*********************************************************
$RTB::MCO::Options = 0;

//*********************************************************
//* GUI Modification
//*********************************************************
if (!isObject(MM_RTBOptionsButton))
{
	%btn = new GuiBitmapButtonCtrl(MM_RTBOptionsButton)
	{
		profile = "GuiDefaultProfile";
		horizSizing = "relative";
		vertSizing = "relative";
		position = "416 200";
		extent = "224 40";
		minExtent = "8 2";
		visible = "1";
		text = " ";
		groupNum = "-1";
		buttonType = "PushButton";
		bitmap = $RTB::Path@"images/buttons/menu/btnOptions";
		command = "RTB_toggleOverlay(0);RTB_Overlay.toggle(RTB_Options);";
		lockAspectRatio = "1";
		alignLeft = "1";
		overflowImage = "0";
		mKeepCached = "1";
		mColor = "255 255 255 255";
	};
	MainMenuGui.add(%btn);
	
	%btn = new GuiBitmapButtonCtrl()
	{
		profile = "BlockButtonProfile";
		position = "10 433";
		extent = "111 25";
		command = "RTB_toggleOverlay(0);RTB_Overlay.toggle(RTB_Options);";
		text = "RTB Options";
		bitmap = "base/client/ui/button1";
	};
	optionsDlg.getObject(0).add(%btn);
}
function MM_RTBOptionsButton::onMouseEnter(%this)
{
	if ($Pref::Audio::MenuSounds)
		alxPlay(Note10Sound);
}

//*********************************************************
//* Module Meat
//*********************************************************
//- RTBCO_registerCategory (register a category for RTBCO_registerOption)
function RTBCO_registerCategory(%catIcon, %catName)
{
	$RTB::MCO::CurrentCategory     = %catName;
	$RTB::MCO::CurrentCategoryIcon = %catIcon;
}

//- RTBCO_registerOption (registers a pref that rtb needs to save/load/manage)
function RTBCO_registerOption(%varName, %value, %uiText)
{
	$RTB::MCO::OptionName[$RTB::MCO::Options]     = %varName;
	$RTB::MCO::OptionDefault[$RTB::MCO::Options]  = %value;
	$RTB::MCO::OptionCategory[$RTB::MCO::Options] = $RTB::MCO::CurrentCategory TAB $RTB::MCO::CurrentCategoryIcon;
	$RTB::MCO::OptionUIText[$RTB::MCO::Options]   = %uiText;
	$RTB::MCO::Options++;
	
	if (RTBCO_getPref(%varName) $= "")
		RTBCO_setPref(%varName, %value);
}

//- RTBCO_getPref (returns value of a pref)
function RTBCO_getPref(%varName)
{
	eval("%return = $RTB::Options::"@%varName@";");
	
	return %return;
}

//- RTBCO_setPref (sets value of a pref)
function RTBCO_setPref(%varName,%value)
{
	eval("$RTB::Options::"@%varName@" = \""@%value@"\";");
}

//- RTBCO_setDefaultPrefs (sets the pref values to default prefs)
function RTBCO_setDefaultPrefs()
{
	for (%i=0;%i<$RTB::MCO::Options;%i++)
		eval("$RTB::Options::"@$RTB::MCO::OptionName[%i]@" = \""@$RTB::MCO::OptionDefault[%i]@"\";");
}

//- RTBCO_Save (saves all the settings)
function RTBCO_Save()
{
	export("$RTB::Options::*","config/client/rtb/prefs.cs");
}

//*********************************************************
//* GUI Functionality
//*********************************************************
//- RTB_Options::onInit (populate the options menu)
function RTB_Options::onInit(%this)
{
	%this.init = true;

	// Local vars for the positioner
	%y       = 2;
	%lastCat = "";
	%lastObj = -1;
	
	// Set new options
	RTB_Options.resizeHeight = true;
	RTB_Options.minExtent    = "266 473";
	
	// Delete everything that currently exists
	RTBCO_Swatch.deleteAll();
	
	// Loop through and create options for every option w/ UI text
	for (%i = 0; %i < $RTB::MCO::Options; %i++)
	{
		%oName     = $RTB::MCO::OptionName[%i];
		%oDefValue = $RTB::MCO::OptionDefault[%i];
		%oValue    = RTBCO_getPref(%oName);
		%oCatName  = getField($RTB::MCO::OptionCategory[%i], 0);
		%oCatIcon  = getField($RTB::MCO::OptionCategory[%i], 1);
		%oUIText   = $RTB::MCO::OptionUIText[%i];
		%oType     = "TOGGLE";
		
		if (%oUIText $= "")
			continue;
		
		// Determine option type
		if (StripChars(%oDefValue, "0123456789") !$= "")
			%oType = "KEYBIND";
		
		// Record category changes
		if (%lastCat !$= %oCatName)
		{
			if (%i != 0)
				%y += 7;
			
			// Save the change
			%lastCat = %oCatName;
			
			// Add a new category header
			%icon = new GuiBitmapCtrl()
			{
				profile     = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing  = "bottom";
				position    = "6" SPC %y;
				extent      = "16 16";
				minExtent   = "8 2";
				visible     = "1";
			};
			%text = new GuiMLTextCtrl()
			{
				profile         = "GuiMLTextProfile";
				horizSizing     = "right";
				vertSizing      = "bottom";
				position        = "26" SPC (%y + 2);
				extent          = "150 12";
				minExtent       = "8 2";
				visible         = "1";
				lineSpacing     = "2";
				allowColorChars = "0";
				maxChars        = "-1";
				text            = "<font:Verdana Bold:12><color:444444>" @ %oCatName;
				maxBitmapHeight = "-1";
				selectable      = "0";
			};
			%sep = new GuiBitmapCtrl()
			{
				profile     = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing  = "bottom";
				position    = "4" SPC (%y + 19);
				extent      = "221 2";
				minExtent   = "8 2";
				visible     = "1";
				bitmap      = "add-ons/system_returntoblockland/images/ui/dottedLine.png";
				wrap        = "1";
			};
			
			// Add the new objects to the swatch
			RTBCO_Swatch.add(%icon);
			RTBCO_Swatch.add(%text);
			RTBCO_Swatch.add(%sep);
			
			// Advance our position
			%y += 24;
			
			// Set the icon
			RTBMM_SetBitmapToIcon(%icon, %oCatIcon);
		}
		
		// Get the option
		if (%oValue $= "")
			%oValue = %oDefValue;
		
		// Create the option
		switch$(%oType)
		{
			case "KEYBIND":
				%text = new GuiMLTextCtrl()
				{
					profile         = "GuiMLTextProfile";
					horizSizing     = "right";
					vertSizing      = "bottom";
					position        = "7" SPC (%y + 2);
					extent          = "126 12";
					minExtent       = "8 2";
					visible         = "1";
					lineSpacing     = "2";
					allowColorChars = "0";
					maxChars        = "-1";
					text            = "<color:888888><font:Verdana:12>" @ %oUIText;
					maxBitmapHeight = "-1";
					selectable      = "0";
				};
				%box = new GuiSwatchCtrl()
				{
					profile     = "GuiDefaultProfile";
					horizSizing = "right";
					vertSizing  = "bottom";
					position    = "139" SPC %y;
					extent      = "84 16";
					minExtent   = "8 2";
					visible     = "1";
					color       = "180 180 180 255";
					
					new GuiSwatchCtrl()
					{
						profile     = "GuiDefaultProfile";
						horizSizing = "width";
						vertSizing  = "height";
						position    = "1 1";
						extent      = "82 14";
						minExtent   = "8 2";
						visible     = "1";
						color       = "255 255 255 255";
					};
				};
				%valueText = new GuiMLTextCtrl(RTBCO_Overlay_Keybind)
				{
					profile         = "GuiMLTextProfile";
					horizSizing     = "right";
					vertSizing      = "bottom";
					position        = "143" SPC (%y + 2);
					extent          = "77 12";
					minExtent       = "8 2";
					visible         = "1";
					lineSpacing     = "2";
					allowColorChars = "0";
					maxChars        = "-1";
					text            = "<font:Verdana:12><color:888888><just:right>" @ strReplace(getField(%oValue, 1), " ", "+");
					maxBitmapHeight = "-1";
					selectable      = "0";
				};
				%button = new GuiBitmapButtonCtrl()
				{
					profile         = "GuiDefaultProfile";
					horizSizing     = "right";
					vertSizing      = "bottom";
					position        = "139" SPC %y;
					extent          = "84 16";
					minExtent       = "8 2";
					visible         = "1";
					command		= "RTB_Options.changeKeybind();";
					groupNum        = "-1";
					buttonType      = "PushButton";
					optionValue     = %oDefValue;
					optionName      = %oName;
				};
				
				// Advance the position
				%y += 18;
				
				// Add to the swatch
				RTBCO_Swatch.add(%text);
				RTBCO_Swatch.add(%box);
				RTBCO_Swatch.add(%valueText);
				RTBCO_Swatch.add(%button);
				
			case "TOGGLE":
				%text = new GuiMLTextCtrl()
				{
					profile         = "GuiMLTextProfile";
					horizSizing     = "right";
					vertSizing      = "bottom";
					position        = "7" SPC (%y + 1);
					extent          = "190 12";
					minExtent       = "8 2";
					visible         = "1";
					lineSpacing     = "2";
					allowColorChars = "0";
					maxChars        = "-1";
					text            = "<color:888888><font:Verdana:12>" @ %oUIText;
					maxBitmapHeight = "-1";
					selectable      = "0";
				};
				%toggle = new GuiCheckBoxCtrl()
				{
					profile         = "RTB_CheckBoxProfile";
					horizSizing     = "right";
					vertSizing      = "bottom";
					position        = "211" SPC (%y + 1);
					extent          = "16 16";
					minExtent       = "8 2";
					visible         = "1";
					groupNum        = "-1";
					buttonType      = "ToggleButton";
					text            = "";
					optionValue     = %oDefValue;
					optionName      = %oName;
				};
				
				// Set value
				%toggle.setValue(%oValue);
				
				// Advance the position
				%y += 18;
				
				// Add to the swatch
				RTBCO_Swatch.add(%text);
				RTBCO_Swatch.add(%toggle);
		}
	}
	
	RTBCO_Swatch.resize(getWord(RTBCO_Swatch.getPosition(), 0), getWord(RTBCO_Swatch.getPosition(), 1), getWord(RTBCO_Swatch.getExtent(), 0), %y);
}

//- RTB_Options::onWake (options wake)
function RTB_Options::onWake(%this)
{
	if (!%this.init)
		%this.onInit();
	
	%binding = strReplace(getField(GlobalActionMap.getBinding("RTB_toggleOverlay"),1)," "," + ");
	
	RTBCO_Overlay_Keybind.setText("<font:Verdana:12><color:888888><just:right>" @ %binding);
	
	for (%i=0;%i<RTBCO_Swatch.getCount();%i++)
	{
		%ctrl = RTBCO_Swatch.getObject(%i);
		if (%ctrl.getClassName() !$= "GuiCheckboxCtrl")
			continue;
			
		%value = RTBCO_getPref(%ctrl.optionName);

		if (%ctrl.getValue() !$= %value)
			%ctrl.performClick();
	}
}

//- RTB_Options::onSleep (options sleep)
function RTB_Options::onSleep(%this)
{
	for (%i = 0; %i < RTBCO_Swatch.getCount(); %i++)
	{
		%ctrl = RTBCO_Swatch.getObject(%i);
		if (%ctrl.getClassName() !$= "GuiCheckboxCtrl")
			continue;

		RTBCO_setPref(%ctrl.optionName,%ctrl.getValue());
	}
	RTBCO_Save();
	
	if (isObject(RTBCO_OV_Remap))
	{
		RTBCO_OV_Remap.delete();
		RTBCO_OV_RemapSwatch.setVisible(false);
	}
	RTBCA_SendPrefs();
}

//- RTB_Options::toggleDependant (toggles dependant blocker)
function RTB_Options::toggleDependant(%this,%ctrl)
{
	if (%ctrl.getValue() $= 1)
		%ctrl.optionDependant.setVisible(false);
	else
		%ctrl.optionDependant.setVisible(true);
}

//- RTB_Options::changeKeybind (opens keybind change window)
function RTB_Options::changeKeybind(%this)
{
	RTBCO_OV_RemapSwatch.setVisible(true);
	
	%remapper = new GuiInputCtrl(RTBCO_OV_Remap);
	RTBCO_OV_RemapSwatch.add(%remapper);
	%remapper.makeFirstResponder(1);
	
	RTBCO_OV_RemapText.setText("<font:Verdana:12><color:888888>Please press a key ...");
}

//- RTBCO_OV_Remap::onInputEvent (captures input and assigns)
function RTBCO_OV_Remap::onInputEvent(%this,%device,%key)
{
	if (%device $= "mouse0")
		return;
		
	if (getWordCount(%key) $= 1 && strLen(%key) $= 1)
	{
		%disallowed = "ABCDEFGHIJKLMNOPQRSTUVWXYZ123456789[]\\/{};:'\"<>,./?!@#$%^&*-_=+`~";
		for (%i=0;%i<strLen(%disallowed);%i++)
		{
			%char = getSubStr(%disallowed,%i,1);
			if (%char $= %key)
			{
				RTBCO_OV_RemapText.setText("<font:Verdana:12><color:888888>You can't use that key.");
				return;
			}
		}
	}
		
	RTBCO_OV_RemapSwatch.setVisible(false);
	RTBCO_Overlay_Keybind.setText("<font:Verdana:12><color:888888><just:right>" @ strReplace(%key," "," + "));
	
	%binding = GlobalActionMap.getBinding("RTB_toggleOverlay");
	GlobalActionMap.unbind(getField(%binding,0),getField(%binding,1));
	GlobalActionMap.bind(%device,%key,"RTB_toggleOverlay");
	
	RTBCO_setPref("OV::OverlayKeybind",%device TAB %key);
	RTBCO_Save();
	
	%this.delete();
}

//*********************************************************
//* Register Options
//*********************************************************

//==========================================================================================================================================================//
//			PrefVar				DefaultValue			UI Text
//==========================================================================================================================================================//

RTBCO_registerCategory("layout",			"Overlay");
RTBCO_registerOption("OV::OverlayKeybind",		"keyboard\tshift tab",		"Toggle Overlay Keybind");
RTBCO_registerOption("OV::EscapeClose",			0,				"Escape key closes overlay windows");

RTBCO_registerCategory("user",				"Client Authentication");
RTBCO_registerOption("CA::AuthWithRTB",			1,				"Authenticate with RTB");
RTBCO_registerOption("CA::Privacy::ShowOnline",		1,				"Show my online status");
RTBCO_registerOption("CA::Privacy::ShowServer",		1,				"Show my current server");

RTBCO_registerCategory("server_database",		"Server Authentication");
RTBCO_registerOption("SA::PostServer",			1,				"Authenticate with RTB");
RTBCO_registerOption("SA::Privacy::ShowPlayers",	1,				"Show players on server");

RTBCO_registerCategory("folder",			"Mod Manager");
RTBCO_registerOption("MM::AnimateGUI",			1,				"Animate gui elements");
RTBCO_registerOption("MM::CheckForUpdates",		1,				"Check for add-on updates");
RTBCO_registerOption("MM::DownloadAvatars",		1,				"Show avatars in comments");

RTBCO_registerCategory("information",			"Info Tips");
RTBCO_registerOption("IT::Enable",			1,				"Enable Info Tips");
RTBCO_registerOption("IT::ShowAddonTips",		1,				"Show Add-On Tips");

RTBCO_registerCategory("plugin",		"GUI Downloading");
RTBCO_registerOption("GT::Enable",			1,				"Enable GUI Downloading");

//==========================================================================================================================================================//

RTBCO_registerCategory("", "");
RTBCO_registerOption("SC::NotifySettings",0);

RTBCO_registerOption("AU::Enable",1);
RTBCO_registerOption("CD::DownloadContent",1);
RTBCO_registerOption("GT::Enable",1);

RTBCO_registerOption("CC::AutoSignIn",1);
RTBCO_registerOption("CC::EnableSounds",1);
RTBCO_registerOption("CC::StickyNotifications",1);
RTBCO_registerOption("CC::ChatLogging",0);
RTBCO_registerOption("CC::SeparateOffline",0);
RTBCO_registerOption("CC::ShowTimestamps",0);
RTBCO_registerOption("CC::SavePositions",1);
RTBCO_registerOption("CC::InviteReq",0);
RTBCO_registerOption("CC::ShowServer",1);
RTBCO_registerOption("CC::AllowPM",1);
RTBCO_registerOption("CC::AllowInvites",1);
RTBCO_registerOption("CC::SignIn::Beep",1);
RTBCO_registerOption("CC::SignIn::Note",0);
RTBCO_registerOption("CC::Message::Beep",1);
RTBCO_registerOption("CC::Message::Note",1);
RTBCO_registerOption("CC::Join::Beep",1);
RTBCO_registerOption("CC::Join::Note",0);
RTBCO_registerOption("CC::PirateMode",0);