const fs        = require('fs');
var dataBlocks  = fs.readFileSync("dataBlocks.txt").toString().replace(/\r/g, "").replace(/\\x[a-fA-F0-9][a-fA-F0-9]/g, "?").replace(/\\\"/g, "\"").split("}");
var UINameTable = {};
var UsedUINames = [];

function ExpandEscape(Text)
{
	while (true)
	{
		var MatchGroup = Text.match(/\\x(?<code>[a-fA-F0-9][a-fA-F0-9])/);
		
		if (MatchGroup != null)
		{
			Text = Text.substr(0, MatchGroup.index) + String.fromCharCode(parseInt(MatchGroup.groups.code, 16)) + Text.substr(MatchGroup.index + MatchGroup[0].length);
		}
		else
		{
			break;
		}
	}
	
	return Text;
}

var dataBlocks = ExpandEscape(fs.readFileSync("dataBlocks.txt").toString().replace(/\r/g, "")).split("}");

for (var i = 0; i < dataBlocks.length; i++)
{
	var MatchData = dataBlocks[i].match(/datablock fxDTSBrickData\s*\(.+?\).+?brickFile\s*=\s*"(?<brickFile>.+?)".+?uiName\s*=\s*"(?<uiName>.+?)"/s);
	
	if (MatchData != null)
	{
		UINameTable[MatchData.groups.uiName] = MatchData.groups.brickFile;
	}
}

var FileOut = [];

for (var i = 0; i < Object.keys(UINameTable).length; i++)
{
	var UIName = Object.keys(UINameTable)[i];
	var BLB    = UINameTable[UIName];
	
	FileOut.push("$MMBuildShowcase::UINameTable[\"" + UIName.replace(/\\"/g, "\"").replace(/"/g, "\\\"") + "\"] = \"" + BLB.replace(/\\"/g, "\"").replace(/"/g, "\\\"") + "\";");
}

fs.writeFileSync ("dataBlocksOutput.txt", FileOut.join("\r\n"));
return;

var Files = fs.readdirSync(".");

for (var jj = 0; jj < Files.length; jj++)
{
	if (!Files[jj].endsWith(".bls"))
		continue;
	
	var NewFileOut   = [];
	var BLSFileIn    = fs.readFileSync(Files[jj]).toString().replace(/\r/g, "").split("\n");
	var LineCountIdx = BLSFileIn.findIndex((x) => x.startsWith("Linecount"));

	NewFileOut.push("This is a Blockland Rebuilt background save file.  You probably shouldn't modify it cause you'll screw it up.");
	NewFileOut.push("1");
	NewFileOut.push(" ");
	NewFileOut.push("ORBIT_DIST 100");
	NewFileOut.push("ORBIT_ROT 0 0 0");
	NewFileOut.push("ORBIT_POS 0 0 0");

	// Write chunk: Colorset data
	for (var i = 0; i < 64; i++)
	{
		NewFileOut.push(BLSFileIn[3 + i]);
	}

	// Write chunk: UI Name Table
	NewFileOut.push("Begin");
	for (var i = LineCountIdx + 1; i < BLSFileIn.length; i++)
	{
		if (BLSFileIn[i].indexOf("\"") === false)
			continue;
		
		var UIName    = BLSFileIn[i].substr(0, BLSFileIn[i].indexOf("\"")).replace(/[^ -\x7F]/g, "?");
		var BrickData = BLSFileIn[i].substr(BLSFileIn[i].indexOf("\"") + 1);
		
		if (!(UIName in UINameTable))
			continue;
		
		NewFileOut.push(UINameTable[UIName] + "\"" + BrickData);
	}

	fs.writeFileSync(Files[jj].substr(0, Files[jj].indexOf(".bls")) + ".blrs", NewFileOut.join("\r\n"));
}