//===========================================================================================================================================//
// Blockland Rebuilt / Client / Canvas
//===========================================================================================================================================//
// 
// This script file is shipped with Blockland Rebuilt in a decompiled form. This file is only for reference!
// Any changes made to this file will break the game. Thank you. -Clay
// 
//===========================================================================================================================================//

// This is 'orrible
function getCanvasScalingPref ()
{
	switch ($pref::Gui::Scaling)
	{
		case 1:
			return 1;
		case 2:
			return 0.5;
		case 3:
			return 0.25;
	}
	
	// Fallback
	return 1;
}

function getCanvasScalingFromCanvas ()
{
	switch (Canvas.getScalingFactor ())
	{
		case 1:
			return 1;
		case 0.5:
			return 2;
		case 0.25:
			return 3;
	}
	
	// Fallback
	return 1;
}

function getNextBestCanvasScaling (%startLevel)
{
	for (%i = %startLevel; %i >= 2; %i--)
		if (getWord (getRes (), 0) >= (640 * %i) && getWord (getRes (), 1) >= (480 * %i))
			return %i;
	
	// Fallback
	return 1;
}

function initCanvas (%windowName)
{
	videoSetGammaCorrection ($pref::OpenGL::gammaCorrection);
	
	// All fallback fonts!!
	registerFallbackFont ("Segoe UI");		// Arabic, Greek, Russian
	registerFallbackFont ("MS Gothic");		// Japanese, Chinese
	registerFallbackFont ("DengXian");		// Japanese, Chinese
	registerFallbackFont ("SimSun");		// Japanese, Chinese
	registerFallbackFont ("Cascadia Mono");		// Greek, Braille (why)
	registerFallbackFont ("Malgun Gothic");		// Korean
	
	// Load our preferred locale
	if (!LoadLocale ($Pref::Gui::LocaleName))
		LoadLocale ("English");
	
	// Hack to get it to actually apply the locale to everything
	schedule (10, 0, reloadLocale);
	
	if (!createCanvas (%windowName))
	{
		quit ();
		return;
	}

	if ($pref::Gui::Scaling != 1 && (getWord (getRes (), 0) < (640 * $pref::Gui::Scaling) || getWord (getRes (), 1) < (480 * $pref::Gui::Scaling)))
	{
		if (isObject (OptScalingSlider))
			OptScalingSlider.setValue (getNextBestCanvasScaling ($pref::Gui::Scaling));
		
		$pref::Gui::Scaling = getNextBestCanvasScaling ($pref::Gui::Scaling);
		Canvas.setScalingFactor (getCanvasScalingPref ());
		messageBoxOk (GetLocaleString ("UI_CONSOLE_CANT_BE_OPENED_TITLE", "NOTICE"), GetLocaleString ("UI_SCALING_SCREEN_TOO_SMALL", "Reverted UI scaling (Resolution too small)."));
	}
	
	// Set our scaling factor. Thanks
	Canvas.setScalingFactor (getCanvasScalingPref ());
	
	setOpenGLTextureCompressionHint ($pref::OpenGL::compressionHint);
	setOpenGLAnisotropy ($pref::OpenGL::anisotropy);
	setOpenGLMipReduction ($pref::OpenGL::mipReduction);
	setOpenGLInteriorMipReduction ($pref::OpenGL::interiorMipReduction);
	setOpenGLSkyMipReduction ($pref::OpenGL::skyMipReduction);
	OpenALInit ();
}

function resetCanvas ()
{
	if (isObject (Canvas))
	{
		Canvas.repaint ();
	}
	if (isObject (PlayGui))
	{
		PlayGui.createInvHud ();
		PlayGui.createToolHud ();
		PlayGui.LoadPaint ();
	}
}

function onWindowReactivate ()
{
	
}

function restartAudio ()
{
	OpenALInit ();
	if (!isObject (ServerConnection))
	{
		return;
	}
	%group = ServerConnection.getId ();
	%count = %group.getCount ();
	%i = 0;
	while (%i < %count)
	{
		%obj = %group.getObject (%i);
		if (%obj.getClassName () $= "AudioEmitter")
		{
			%profile = %obj.profile;
			%obj.profile = 0;
			%obj.profile = %profile;
			%obj.schedule (10, update);
		}
		%i += 1;
	}
}

