//===========================================================================================================================================//
// Blockland Rebuilt / Client / MissionDownload
//===========================================================================================================================================//
// 
// This script file is shipped with Blockland Rebuilt in a decompiled form. This file is only for reference!
// Any changes made to this file will break the game. Thank you. -Clay
// 
//===========================================================================================================================================//

function onNewManifestItemReceived ()
{
	updateFileTransferDialog (true);
	
	$CDNCheckIndex = 0;
	if ($totalPendingBlobs == 1)
	{
		$LoadingProgressTxt.setValue ("<textid:UI_LOADING_CHECKING_CDN_FOR_FILE:CHECKING CDN FOR 1 FILE>");
	}
	else 
	{
		$LoadingProgressTxt.setValue ("<textid:UI_LOADING_CHECKING_CDN_FOR_FILES:CHECKING CDN FOR %s FILES:" @ getSanitizedTextIDArg ($totalPendingBlobs) @ ">");
	}
	$LoadingProgress.setValue (0);
	$LoadingSecondaryProgress.setValue (0);
}

function onManifestHashReceived ()
{
	updateFileTransferDialog (true);
	$manifestPending = 1;
	$LoadingProgressTxt.setValue ("<textid:UI_LOADING_DOWNLOADING_MANIFEST:DOWNLOADING FILE MANIFEST>");
	$LoadingProgressTxt.setCenterY ();
	$LoadingProgress.setValue (0);
	$LoadingSecondaryProgress.setValue (0);
}

function onManifestRecieved ()
{
	$manifestPending = 0;
	$totalPendingBlobs = 0;
}

function setTotalPendingBlobs (%tpb)
{
	$totalPendingBlobs = %tpb;
	
	if ($currentBlobName $= "")
		$blobsRemainingText = "<textid:UI_LOADING_DOWNLOADING_FROM_CDN:DOWNLOADING FILE FROM CDN (%s OF %s):" @ getSanitizedTextIDArg (($totalPendingBlobs - $totalBlobsRemaining) + 1) @ ":" @ getSanitizedTextIDArg ($totalPendingBlobs) @ ">";
	else
		$blobsRemainingText = "<textid:UI_LOADING_DOWNLOADING_FROM_SERVER:DOWNLOADING FILE (%s OF %s):" @ getSanitizedTextIDArg (($totalPendingBlobs - $totalBlobsRemaining) + 1) @ ":" @ getSanitizedTextIDArg ($totalPendingBlobs) @ ">\n'" @ $currentBlobName @ "'";
}

function updateFileTransferDialog (%downloadingFile)
{
	%FTPWindowIsOnPlayGui  = (FTP_Window.getParent ().getName () $= "PlayGui");
	%FTPWindowShouldBeOpen = PlayGui.isAwake () && %downloadingFile;
	
	// Setup object variables
	if (!isObject ($LoadingProgressTxt))
		$LoadingProgressTxt       = (%FTPWindowShouldBeOpen ? FTP_LoadingProgressTxt.getId () : LoadingProgressTxt.getId ());
	if (!isObject ($LoadingProgress))
		$LoadingProgress          = (%FTPWindowShouldBeOpen ? FTP_LoadingProgress.getId () : LoadingProgress.getId ());
	if (!isObject ($LoadingSecondaryProgress))
		$LoadingSecondaryProgress = (%FTPWindowShouldBeOpen ? FTP_LoadingSecondaryProgress.getId () : LoadingSecondaryProgress.getId ());
	
	if (%FTPWindowShouldBeOpen)
	{
		if (FTP_Window.getParent ().getName () !$= "PlayGui")
		{
			PlayGui.add(FTP_Window);
			FTP_Window.setCenter(PlayGui.getWidth() / 2, (FTP_Window.getHeight() / 2) + 16);
			
			// Update variables
			$LoadingProgressTxt       = FTP_LoadingProgressTxt.getId ();
			$LoadingProgress          = FTP_LoadingProgress.getId ();
			$LoadingSecondaryProgress = FTP_LoadingSecondaryProgress.getId ();
		}
	}
	else
	{
		if (FTP_Window.getParent ().getName () $= "PlayGui")
		{
			FileTransferProgressGui.add(FTP_Window);
			
			// Update variables
			$LoadingProgressTxt       = LoadingProgressTxt.getId ();
			$LoadingProgress          = LoadingProgress.getId ();
			$LoadingSecondaryProgress = LoadingSecondaryProgress.getId ();
		}
	}
}

function onBlobCacheCheckFinished ()
{
	updateFileTransferDialog (true);
	
	$CDNCheckIndex = 0;
	if ($totalPendingBlobs == 1)
	{
		$LoadingProgressTxt.setValue ("CHECKING CDN FOR 1 FILE");
		$LoadingProgressTxt.setValue ("<textid:UI_LOADING_CHECKING_CDN_FOR_FILE:CHECKING CDN FOR 1 FILE>");
	}
	else 
	{
		$LoadingProgressTxt.setValue ("<textid:UI_LOADING_CHECKING_CDN_FOR_FILES:CHECKING CDN FOR %s FILES:" @ getSanitizedTextIDArg ($totalPendingBlobs) @ ">");
	}
	$LoadingProgressTxt.setCenterY ();
	$LoadingProgress.setValue (0);
	$LoadingSecondaryProgress.setValue (0);
}

function OnCDNBlobChecked ()
{
	updateFileTransferDialog (true);
	$LoadingSecondaryProgress.setValue ($CDNCheckIndex / $totalPendingBlobs);
	$CDNCheckIndex++;
}

function updateBlobsRemaining (%blobsRemaining, %blobName)
{
	updateFileTransferDialog (true);
	
	if ($manifestPending && %blobsRemaining == 1)
	{
		$LoadingProgressTxt.setValue ("<textid:UI_LOADING_DOWNLOADING_MANIFEST:DOWNLOADING FILE MANIFEST>");
		$LoadingProgressTxt.setCenterY ();
		$LoadingProgress.setValue (0);
		$LoadingSecondaryProgress.setValue (0);
		$blobsRemainingText = $LoadingProgressTxt.getValue();
		return;
	}
	if (%blobsRemaining > $totalPendingBlobs)
	{
		$totalPendingBlobs = %blobsRemaining;
	}
	if ($totalPendingBlobs > 0)
	{
		if (stripMLControlChars(%blobName) $= "")
			$LoadingProgressTxt.setValue ("<textid:UI_LOADING_DOWNLOADING_FROM_CDN:DOWNLOADING FILE FROM CDN (%s OF %s):" @ getSanitizedTextIDArg (($totalPendingBlobs - $totalBlobsRemaining) + 1) @ ":" @ getSanitizedTextIDArg ($totalPendingBlobs) @ ">");
		else
			$LoadingProgressTxt.setValue ("<textid:UI_LOADING_DOWNLOADING_FROM_SERVER:DOWNLOADING FILE (%s OF %s):" @ getSanitizedTextIDArg (($totalPendingBlobs - $totalBlobsRemaining) + 1) @ ":" @ getSanitizedTextIDArg ($totalPendingBlobs) @ ">\n'" @ stripMLControlChars (%blobName) @ "'");
		
		$LoadingProgressTxt.setCenterY ();
		$LoadingProgress.setValue (($totalPendingBlobs - %blobsRemaining) / $totalPendingBlobs);
		$LoadingSecondaryProgress.setValue (0);
		Canvas.repaint ();
	}
	
	$totalBlobsRemaining = %blobsRemaining;
	$currentBlobName = stripMLControlChars(%blobName);
	$blobsRemainingText = $LoadingProgressTxt.getValue();
}

function onBlobDownloadFinished ()
{
	updateFileTransferDialog (false);
	$LoadingProgressTxt.setValue ("<textid:UI_LOADING_DATABLOCKS:LOADING DATABLOCKS>");
	$LoadingProgressTxt.setCenterY ();
	$LoadingSecondaryProgress.setValue (0);
	$LoadingProgress.setValue (0);
	commandToServer ('BlobDownloadFinished');
}

function setDownloadSize (%size)
{
	$currDownloadSize = %size;
}

function updateDownloadProgress (%val)
{
	%percent = %val / $currDownloadSize;
	
	$LoadingSecondaryProgress.setValue (%percent);
	
       if ($currDownloadSize >= 1048576)
            %progressText = mFloatLength(%val              / 1048576, 1) @ " OF " @
                            mFloatLength($currDownloadSize / 1048576, 1) @ " MiB";
        else if ($currDownloadSize >= 1024)
            %progressText = mFloatLength(%val              / 1024, 1) @ " OF " @
                            mFloatLength($currDownloadSize / 1024, 1) @ " KiB";
        else
            %progressText = %val @ " OF " @ $currDownloadSize @ " bytes";
	
//        $LoadingProgressTxt.setValue (trim (getRecord ($blobsRemainingText, 0) @ "   \x97   " @ %progressText NL getRecord ($blobsRemainingText, 1)));
        $LoadingProgressTxt.setValue (trim (getRecord ($blobsRemainingText, 0) @ "   \u2014   " @ %progressText NL getRecord ($blobsRemainingText, 1)));
	$LoadingProgressTxt.setCenterY ();
}

function clientCmdMissionStartPhase1 (%seq, %missionName, %musicTrack, %envControlEnabled)
{
	echo ("*** New Mission: " @ %missionName);
	echo ("*** Phase 1: Download Datablocks & Targets");
	$isEnvironmentControlEnabled = atoi(%envControlEnabled);
	onMissionDownloadPhase1 (%missionName, %musicTrack);
	commandToServer ('MissionStartPhase1Ack', %seq);
}

function onDataBlockObjectReceived (%index, %total)
{
	onPhase1Progress (%index / %total);
}

function clientCmdMissionStartPhase2 (%seq, %missionName)
{
	onPhase1Complete ();
	echo ("*** Phase 2: Download Ghost Objects");
	purgeResources ();
	onMissionDownloadPhase2 (%missionName);
	commandToServer ('MissionStartPhase2Ack', %seq);
}

function onGhostAlwaysStarted (%ghostCount)
{
	$ghostCount = %ghostCount;
	$ghostsRecvd = 0;
}

function onGhostAlwaysObjectReceived ()
{
	$ghostsRecvd += 1;
	onPhase2Progress ($ghostsRecvd / $ghostCount);
}

function clientCmdMissionStartPhase3 (%seq, %missionName)
{
	onPhase2Complete ();
	StartClientReplication ();
	StartFoliageReplication ();
	StartGrassReplication ();
	echo ("*** Phase 3: Mission Lighting");
	$MSeq = %seq;
	$Client::MissionFile = %missionName;
	if (lightScene ("sceneLightingComplete", ""))
	{
		echo ("Lighting mission....");
		schedule (1, 0, "updateLightingProgress");
		onMissionDownloadPhase3 (%missionName);
		$lightingMission = 1;
	}
}

function updateLightingProgress ()
{
	onPhase3Progress ($SceneLighting::lightingProgress);
	if ($lightingMission)
	{
		$lightingProgressThread = schedule (1, 0, "updateLightingProgress");
	}
}

function sceneLightingComplete ()
{
	echo ("Mission lighting done");
	onPhase3Complete ();
	onMissionDownloadComplete ();
	commandToServer ('MissionStartPhase3Ack', $MSeq);
	commandToServer ('RequestNamedTargets');
}

